package com.example.demo.user;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.*;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.stream.Collector;
import java.util.stream.Collectors;

@Controller
@RequestMapping(path="/users")
public class UserController {
    @Autowired
    private UserRepository repository;

    @GetMapping(path="/new")
    public String newUser(Model model){
        model.addAttribute("user", new User());
        return "users/new";
    }

    @PostMapping
    public String create(@ModelAttribute User user){
        repository.save(user);
        return "redirect:users";
    }

    @RequestMapping(value="/{id}")
    public String get(@PathVariable long id, Model model){
        model.addAttribute("user", repository.findById(id));
        return "users/show";
    }

    @GetMapping
    public String index(Model model){
        model.addAttribute("allUsers", repository.findAll());
        return "users/index";
    }




}
